unit Mainwin;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, PIGGraph, StdCtrls, Rzlabel, Menus;

const
  PIG_GRAPH_SERIE_NB_MAX = 5;


type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    popmnuGraph: TPopupMenu;
    popmnuGraphX: TMenuItem;
    popmnuGraphXDouble: TMenuItem;
    popmnuGraphXDivide: TMenuItem;
    popmnuGraphXAjustToMinMax: TMenuItem;
    popmnuGraphXAjustToLastPoints: TMenuItem;
    popmnuGraphY: TMenuItem;
    popmnuGraphYMaxDouble: TMenuItem;
    popmnuGraphYMaxDivide: TMenuItem;
    popmnuGraphYMinDouble: TMenuItem;
    popmnuGraphYMinDivide: TMenuItem;
    popmnuGraphYAjustToMinMax: TMenuItem;
    popmnuGraphSeparator2: TMenuItem;
    popmnuGraphZoomOut: TMenuItem;
    popmnuGraphZoomIn: TMenuItem;
    N1: TMenuItem;
    popmnuGraphShowGrid: TMenuItem;
    popmnuGraphShowPoints: TMenuItem;
    popmnuGraphUndoSeparator: TMenuItem;
    popmnuGraphUndo: TMenuItem;
    popmnuGraphReset: TMenuItem;
    Label1: TLabel;
    Timer1: TTimer;
    N2: TMenuItem;
    popmnuSimulationStart: TMenuItem;
    popmnuSimulationStop: TMenuItem;
    PIGGraph1: TPIGGraph;
    procedure popmnuGraphXDoubleClick(Sender: TObject);
    procedure popmnuGraphXDivideClick(Sender: TObject);
    procedure popmnuGraphXAjustToMinMaxClick(Sender: TObject);
    procedure popmnuGraphXAjustToLastPointsClick(Sender: TObject);
    procedure popmnuGraphYMaxDoubleClick(Sender: TObject);
    procedure popmnuGraphYMaxDivideClick(Sender: TObject);
    procedure popmnuGraphYMinDoubleClick(Sender: TObject);
    procedure popmnuGraphYAjustToMinMaxClick(Sender: TObject);
    procedure popmnuGraphZoomOutClick(Sender: TObject);
    procedure popmnuGraphZoomInClick(Sender: TObject);
    procedure popmnuGraphShowGridClick(Sender: TObject);
    procedure popmnuGraphYMinDivideClick(Sender: TObject);
    procedure popmnuGraphResetClick(Sender: TObject);
    procedure popmnuGraphUndoClick(Sender: TObject);
    procedure PigGraph1Zoom(Sender: TObject; XMinBefore, XMaxBefore,
      YMinBefore, YMaxBefore: Real; var XMinAfter, XMaxAfter, YMinAfter,
      YMaxAfter: Real);
    procedure PigGraph1Pan(Sender: TObject; XMinBefore, XMaxBefore,
      YMinBefore, YMaxBefore, XMinAfter, XMaxAfter, YMinAfter,
      YMaxAfter: Real);
    procedure popmnuGraphShowPointsClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure popmnuSimulationStartClick(Sender: TObject);
    procedure popmnuSimulationStopClick(Sender: TObject);
  private
    { Private declarations }
    fT: single;

    fLastYMax: single;
    fLastYMin: single;
    fLastXMax: single;
    fLastXMin: single;

    procedure SaveGraphLimits;
    procedure SaveGraphLimitsValues(p_fXmin, p_fXMax, p_fYMin, p_fYMax: real);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

Function Min(i,j: extended): extended;
Function Max(i,j: extended): extended;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin

   PIGGraph1.XMin := -50.0;
   PIGGraph1.XMax :=   0.0;

   PIGGraph1.ShowSeries(0);
   PIGGraph1.ShowSeries(1);
   PIGGraph1.ShowSeries(2);
   PIGGraph1.ShowSeries(3);
   PIGGraph1.ShowSeries(4);


end;


procedure TForm1.popmnuSimulationStartClick(Sender: TObject);
begin

   popmnuSimulationStart.visible := false;
   popmnuSimulationStop .visible := true;

   timer1.interval := 1;

end;

procedure TForm1.popmnuSimulationStopClick(Sender: TObject);
begin

   popmnuSimulationStart.visible := true;
   popmnuSimulationStop .visible := false;

   timer1.interval := 0;

end;

procedure TForm1.popmnuGraphYMaxDivideClick(Sender: TObject);
begin

  SaveGraphLimits;

  PIGGraph1.YMax := PIGGraph1.YMax/2.0;

end;


procedure TForm1.popmnuGraphYMaxDoubleClick(Sender: TObject);
begin

  SaveGraphLimits;

  PIGGraph1.YMax := PIGGraph1.YMax*2.0;

end;


procedure TForm1.popmnuGraphYminDivideClick(Sender: TObject);
begin

  SaveGraphLimits;

  PIGGraph1.YMin := PIGGraph1.YMin/2.0;

end;


procedure TForm1.popmnuGraphYminDoubleClick(Sender: TObject);
begin

  SaveGraphLimits;

  PIGGraph1.YMin := PIGGraph1.YMin*2.0;

end;


procedure TForm1.popmnuGraphXAjustToMinMaxClick(Sender: TObject);
begin

   if PIGGraph1.XCount > 2 then
      begin

      SaveGraphLimits;

      PIGGraph1.RePaint := false;
      PIGGraph1.XMin := Max(0,PIGGraph1.XCount-PIGGraph1.NValues);
      PIGGraph1.XMax := PIGGraph1.XCount;
      PIGGraph1.RePaint := true;
      PIGGraph1.Paint;

      end;

end;


procedure TForm1.popmnuGraphXAjustToLastPointsClick(Sender: TObject);
var
   fDelta: single;

begin

   SaveGraphLimits;

   PIGGraph1.RePaint := false;
   fDelta := PIGGraph1.XMax - PIGGraph1.XMin;
   PIGGraph1.XMax := PIGGraph1.XCount;
   PIGGraph1.XMin := PIGGraph1.XMax - fDelta;
   PIGGraph1.RePaint := true;
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphUndoClick(Sender: TObject);
begin

   PIGGraph1.RePaint := false;
   PIGGraph1.YMax    := fLastYMax;
   PIGGraph1.YMin    := fLastYMin;
   PIGGraph1.XMax    := fLastXMax;
   PIGGraph1.XMin    := fLastXMin;
   PIGGraph1.RePaint := true;
   PIGGraph1.Paint;

   (sender as TMenuItem).visible := false;

end;



procedure TForm1.popmnuGraphXDoubleClick(Sender: TObject);
begin

   SaveGraphLimits;

   PIGGraph1.XMin := PIGGraph1.XMin - (PIGGraph1.XMax - PIGGraph1.XMin);
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphXDivideClick(Sender: TObject);
begin

   SaveGraphLimits;

   PIGGraph1.XMin := (PIGGraph1.XMax + PIGGraph1.XMin)/2.0;
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphZoomInClick(Sender: TObject);
begin

   SaveGraphLimits;
   PIGGraph1.RePaint := false;
   PIGGraph1.ZoomY   := PIGGraph1.ZoomY * 2.0;
   PIGGraph1.PosY    := PIGGraph1.PosY + (PIGGraph1.Height/2)/PIGGraph1.ZoomY;
   PIGGraph1.ZoomX   := PIGGraph1.ZoomX / 2.0;
   PIGGraph1.PosX    := PIGGraph1.PosX + (PIGGraph1.Width/2)*PIGGraph1.ZoomX;
   PIGGraph1.RePaint := true;
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphZoomOutClick(Sender: TObject);
begin

   SaveGraphLimits;

   PIGGraph1.RePaint := false;
   PIGGraph1.PosY    := PIGGraph1.PosY - (PIGGraph1.Height/2)/PIGGraph1.ZoomY;
   PIGGraph1.ZoomY   := PIGGraph1.ZoomY / 2.0;
   PIGGraph1.PosX    := PIGGraph1.PosX - (PIGGraph1.Width/2)*PIGGraph1.ZoomX;
   PIGGraph1.ZoomX   := PIGGraph1.ZoomX * 2.0;
   PIGGraph1.RePaint := true;
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphYAjustToMinMaxClick(Sender: TObject);
var
   fMax: single;
   fMin: single;
   i: integer;
   j: integer;

begin

   fMax := -1e30;
   fMin := +1e30;

   for i := 0 to PIGGraph1.XCount-1 do
      for j := 0 to PIG_GRAPH_SERIE_NB_MAX-1 do
         if PIGGraph1.IsSeriesVisible(j) then
            begin
            if PIGGraph1.GetPoint(j,i) > fMax then
               fMax := PIGGraph1.GetPoint(j,i);
            if PIGGraph1.GetPoint(j,i) < fMin then
               fMin := PIGGraph1.GetPoint(j,i);
            end;

   if fMax < fMin then
      begin
      fMax := 100.0;
      fMin := 0.0;
      end
   else if fMax = fMin then
      begin
      fMax := fMin + 50.0;
      fMin := fMin - 50.0;
      end;

   PIGGraph1.RePaint := false;
   PIGGraph1.YMin    := fMin;
   PIGGraph1.YMax    := fMax;
   PIGGraph1.RePaint := true;
   PIGGraph1.Paint;

end;


procedure TForm1.popmnuGraphShowGridClick(Sender: TObject);
begin

   (sender as TMenuItem).Checked := (not (sender as TMenuItem).Checked);

   PIGGraph1.ShowGrid := (sender as TMenuItem).Checked;

end;



procedure TForm1.PIGGraph1Zoom(Sender: TObject; XMinBefore, XMaxBefore,
  YMinBefore, YMaxBefore: Real; var XMinAfter, XMaxAfter, YMinAfter,
  YMaxAfter: Real);
begin

   SaveGraphLimitsValues(XMinBefore,XMaxBefore,YMinBefore,YMaxBefore);

end;


procedure TForm1.SaveGraphLimits;
begin

   SaveGraphLimitsValues(PIGGraph1.XMin,PIGGraph1.XMax,PIGGraph1.YMin,PIGGraph1.YMax);

end;


procedure TForm1.SaveGraphLimitsValues(p_fXmin, p_fXMax, p_fYMin, p_fYMax: real);
begin

   fLastYMax := p_fYMax;
   fLastYMin := p_fYMin;
   fLastXMax := p_fXMax;
   fLastXMin := p_fXMin;

   popmnuGraphUndo         .visible := true;
   popmnuGraphUndoSeparator.visible := true;

end;


procedure TForm1.popmnuGraphShowPointsClick(Sender: TObject);
begin

   (sender as TMenuItem).Checked := (not (sender as TMenuItem).Checked);

   PIGGraph1.ShowPoint := (sender as TMenuItem).Checked;

end;



procedure TForm1.popmnuGraphResetClick(Sender: TObject);
begin

   PIGGraph1.ResetIndex;

end;





procedure TForm1.PigGraph1Pan(Sender: TObject; XMinBefore, XMaxBefore,
  YMinBefore, YMaxBefore, XMinAfter, XMaxAfter, YMinAfter,
  YMaxAfter: Real);
begin

   SaveGraphLimitsValues(XMinBefore,XMaxBefore,YMinBefore,YMaxBefore);

end;



procedure TForm1.Timer1Timer(Sender: TObject);
var
   fAmp:       single;
   fH:         single;
   fPeriod:    single;
   fSampling:  single;
   fValue:     single;
   fVariation: single;

   i: integer;

begin

   fAmp      := 100.0;
   fH        :=  50.0;
   fPeriod   :=  50.0;
   fSampling :=   1.0;

   fT  := fT + fSampling;
   fValue := fH + 0.5 * fAmp * sin ( 2*Pi/fPeriod * fT );

   PIGGraph1.SetPoint(0,fValue);
   PIGGraph1.SetPoint(1,fValue / 2.0);
   PIGGraph1.SetPoint(2,abs(fH-fValue));
   if fValue > 50 then fValue := 60 else fValue := 40;
   PIGGraph1.SetPoint(3,fValue);
   i := PIGGraph1.XCount;
   fVariation := (PIGGraph1.GetPoint(0,i)-PIGGraph1.GetPoint(2,i))*0.1;
   PIGGraph1.SetPoint(4,fVariation);
   PIGGraph1.NextPoint;
   PIGGraph1.Show;

end;



Function Min;
begin
   if i < j then
      Min := i
   else
      Min := j;
end;


Function Max;
begin
   if i > j then
      Max := i
   else
      Max := j;
end;


end.
